Foreman - Bug #2317

Foreman starts creating VM's with the name foreman_########
03/13/2013 09:11 PM - Anonymous

Status: Closed

Priority: Normal

Assignee: Joseph Magen

Category: Compute resources - oVirt

Target version: 1.2.0

Difficulty: Fixed in Releases:
Triaged: Found in Releases:
Bugzilla link: Red Hat JIRA:

Pull request:

Description

Once and awhile Foreman starts creating VM's on our RHEV instance with names like foreman_32546452 instead of using the
FQDN name with dashes instead of dots, as it normally does.

I have not been able to track down what is causing this or what clears it, but after attempts of stopping and starting foreman, puppet,
ovirt-engine and closing my browser and clearing the cache the desired behaviour will resume.

I'm not sure how | can debug this beyond providing /var/log/foreman/production.log the next time it happens.

Associated revisions

Revision 557b8543 - 06/25/2013 10:31 AM - Joseph Magen
fixes #2317 - VM's with the name foreman_ #######H

Revision 073aff2e - 06/28/2013 11:50 AM - Joseph Magen
fixes #2317 - VM's with the name foreman_ #######
(cherry picked from commit 557b8543¢c26619442be7412ddd5780ec7¢c550605)

History

#1 - 03/26/2013 10:41 AM - Anonymous

- File wrongname.png added

| think what | am finding is that this happens when | have a browser session open, do some stuff, create/delete vm's (I'm using RHEV in my case) etc.
and then restart the (httpd, using passenger) service, perhaps a few times. If | don't log out/clear my browser history this seems to occasionally
happen. When it does happen, clearing my browser cache seems to get it functioning correctly again.

#2 - 03/28/2013 04:05 AM - Ohad Levy

this some how were hash attributes (the default vm hash) is merged with the requested details incorrectly (probably in the wrong direction).

#3 - 04/11/2013 02:16 PM - Dominic Cleal
- Category set to Compute resources - oVirt

- Target version set to 1.2.0

#4 - 05/30/2013 02:23 PM - Ohad Levy

- Assignee set to Joseph Magen

#5 - 06/03/2013 04:50 AM - Joseph Magen

- Status changed from New to Assigned

#6 - 06/03/2013 10:31 AM - Joseph Magen

- Status changed from Assigned to Need more information
Jason, | could not duplicate this issue. If the name is blank, then the default name is foreman_#### because of this method in compute_resource.rb

def vm_instance_defaults
{
'name' => "foreman_#{Time.now.to_i}",
}

end
When it's created, the default name is overridden

def new_vm(attr={})
vm = client.servers.new vm_instance_defaults.merge (attr)

| cannot reproduce when the name is blank and it's NOT caught by the validation errors.

#7 - 06/03/2013 10:35 AM - Anonymous

| have had a hard time reproducing it as well. | can make it happen in 1.1stable3 (have not tried hard with 1.2-RC1) it seems if | do some stuff -
create/delete hosts, etc. and am frequently restarting the httpd service (using passenger) in between doing things. | encountered it fairly often when
testing the setup early on when getting everything configured, but now that things are running and the service is not being frequently restarted it pretty
much does not happen.

#8 - 06/04/2013 05:30 AM - Ohad Levy
Joseph, could this be that we are not using a hash_with_in_differnce ?
maybe we somehow do {"name" => ..}.merge(:name => ..) ?

#9 - 06/05/2013 04:50 AM - Joseph Magen

good point, it could be {"name" => ..}.merge(:name => .. | will look into further

#10 - 06/14/2013 04:23 AM - Toni Schmidbauer

I'm hitting the same bug. just tried to create a new ovirt guest and got the foreman_###... name in ovirt. deleting the guest and recreating it did not
help. but after restarting apache and once again creating the machine, everything is back to normal (no foreman_### name in ovirt and foreman).

#11 - 06/19/2013 10:26 AM - Joseph Magen

https://github.com/theforeman/foreman/pull/733

Jason, Toni,

Can you try this fix? https:/github.com/theforeman/foreman/pull/733

I'm guess the merged hash contained both "name" and :name as keys

{"name" => foreman_234234234, :name => 'the_real_name'}
vm_instance_defaults.merge(attr.to_hash.symbolize_keys)

now vm_instance_defaults has :name as the key, so it will be overwritten by {:name => 'the_real_name'}

#12 - 06/19/2013 10:27 AM - Joseph Magen

- Status changed from Need more information to Ready For Testing

#13 - 06/21/2013 12:27 PM - Anonymous

| have been trying repeatedly to reproduce this (using what | think is the reproducer of restarting httpd while | have an open session and then trying to
create a VM) and so far it has not happened, so | think this might have been it. :)

I'll continue to try to get it to do the wrong thing, but so far so good.
#14 - 06/21/2013 03:02 PM - Toni Schmidbauer
didn't happen to me after applying your patch. i'm going to create a few test vm's on monday, if i hit this bug again i will update the case.

thanks
toni

#15 - 06/25/2013 01:17 PM - Joseph Magen
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100
https://github.com/theforeman/foreman/pull/733
https://github.com/theforeman/foreman/pull/733

Applied in changeset 557b8543c26619442be7412ddd5780ec7¢550605.
